/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	PIBSMTP:				*/
/*	Program purpose is to update pop/imap	*/
/*	access with environment data given by	*/
/*	dovecot					*/
/*						*/
/*	List will be used to make a list of	*/
/*	IP used by remote user to read their	*/
/*	mail, this list will be used to allow	*/
/*	relaying.				*/
/*						*/
/************************************************/
#include	<errno.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<malloc.h>
#include	<string.h>
#include	<getopt.h>
#include	"subrou.h"
#include	"gespbs.h"

/*

*/
/************************************************/
/*						*/
/*	Program usage help			*/
/*						*/
/************************************************/
static void usage()

{
(void) fprintf(stderr,"%s Version %s\n",PIBSMTP,rou_getvers());
(void) fprintf(stderr,"usage: %s [options] [program_to_call]"
		      "[-h "
		      "[-b base] "
		      "[-d debug] "
		      "[-v ] "
		      "\n",PIBSMTP);
(void) fprintf(stderr,"\t\t-d program   : program to call at the end\n");
(void) fprintf(stderr,"\t\t-h           : this help\n");
(void) fprintf(stderr,"\t\t-b base      : application working directory\n");
(void) fprintf(stderr,"\t\t-d debug     : debug level\n");
(void) fprintf(stderr,"\t\t-v           : verbose debug\n");
}
/*
^L
*/
/************************************************/
/*						*/
/*	Program Entry.				*/
/*						*/
/************************************************/
int main(int argc,char *argv[])

{
char c;
char *nextcall;
char **locargv;
int locargc;

base=strdup(base);
nextcall=(char *)0;
locargv=(char **)calloc(argc,sizeof(char *));
locargc=0;
while ((c=getopt(argc,argv,"+b:d:hv"))!=EOF) {
  switch(c) {
    case   'b'  :
      (void) free(base);
      base=rou_mkbase(optarg);
      break;
    case   'd'  :
      debug=atoi(optarg);
      break;
    case   'h'  :
    default	:
      (void) usage();
      break;
    case   'v'  :
      verbose=true;
      break;
    }
  }
if (argc>optind) {
  int i;

  nextcall=argv[optind];
  optind++;
  for (i=optind;i<argc;i++) {
    locargv[locargc]=argv[i];
    locargc++;
    }
  }
(void) rou_chgid(appname);
(void) pbs_addentry(getenv("USER"),getenv("IP"));
/*let take back our previous ID		*/
if (setegid(getgid())<0) {
  (void) alert(0,"%s Unable to set the Egid to '%d'",getgid());
  }
if (seteuid(getuid())<0) {
  (void) alert(0,"%s Unable to set the Euid to '%d'",getuid());
  }
if (nextcall!=(char *)0) {
  (void) execve(nextcall,locargv,environ);
  }
(void) free(base);
return 0;
}
